window.addEventListener("load", () => {
  // dialog controls
  (() => {
    if (document.querySelectorAll(".modal-open").length) {
      document.querySelectorAll(".modal-open").forEach((button) => {
        const modalId = button.getAttribute("data-modal-trigger");
        const dialog = document.getElementById(`dialog-${modalId}`);

        if (!dialog) return;

        const closeButton = dialog.querySelector(".modal-close");

        button.addEventListener("click", () => {
          dialog.showModal();
          dialog.classList.remove("closing");
        });

        if (closeButton)
          closeButton.addEventListener("click", () => {
            dialog.classList.add("closing");
            setTimeout(() => dialog.close(), 200);
          });

        dialog.addEventListener("click", (event) => {
          const rect = dialog.getBoundingClientRect();

          if (
            event.clientX < rect.left ||
            event.clientX > rect.right ||
            event.clientY < rect.top ||
            event.clientY > rect.bottom
          ) {
            dialog.classList.add("closing");
            setTimeout(() => dialog.close(), 200);
          }
        });


        dialog.addEventListener("cancel", (event) => {
          event.preventDefault();
          dialog.classList.add("closing");
          setTimeout(() => dialog.close(), 200);
        });
      });
    }
  })();

  // text toggle for media pages
  (() => {
    const button = document.querySelector("[data-toggle-button]");
    const content = document.querySelector("[data-toggle-content]");
    const text = document.querySelectorAll("[data-toggle-content] p");
    const minHeight = 500; // this needs to match the height set on [data-toggle-content].text-toggle-hidden in text-toggle.css
    const interiorHeight = Array.from(text).reduce(
      (acc, node) => acc + node.scrollHeight,
      0,
    );

    if (!button || !content || !text) return;

    if (interiorHeight < minHeight) {
      content.classList.remove("text-toggle-hidden");
      button.style.display = "none";
      return;
    }

    button.addEventListener("click", () => {
      const isHidden = content.classList.toggle("text-toggle-hidden");
      button.textContent = isHidden ? "Show more" : "Show less";
    });
  })();
});
